/*
 * Project: MoleCuilder
 * Description: creates and alters molecular systems
 * Copyright (C)  2012 University of Bonn. All rights reserved.
 * 
 *
 *   This file is part of MoleCuilder.
 *
 *    MoleCuilder is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    MoleCuilder is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * AtomOfMoleculeDescriptor.cpp
 *
 *  Created on: Dec 19, 2011
 *      Author: heber
 */

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

//#include "CodePatterns/MemDebug.hpp"

#include "AtomOfMoleculeDescriptor.hpp"
#include "AtomOfMoleculeDescriptor_impl.hpp"

#include "Atom/atom.hpp"
#include "molecule.hpp"
#include "CodePatterns/Observer/ObservedContainer_impl.hpp"

using namespace std;


AtomOfMoleculeDescriptor_impl::AtomOfMoleculeDescriptor_impl(moleculeId_t _id) :
  id(_id)
{}

AtomOfMoleculeDescriptor_impl::~AtomOfMoleculeDescriptor_impl()
{}

bool AtomOfMoleculeDescriptor_impl::predicate(std::pair<atomId_t,const atom*> atom) const
{
  if (atom.second->getMolecule() == NULL)
    return false;
  else
    return atom.second->getMolecule()->getId() == id;
}

AtomDescriptor AtomOfMolecule(moleculeId_t id)
{
  return AtomDescriptor(AtomDescriptor::impl_ptr(new AtomOfMoleculeDescriptor_impl(id)));
}
