/*
 * Project: MoleCuilder
 * Description: creates and alters molecular systems
 * Copyright (C)  2010-2012 University of Bonn. All rights reserved.
 * 
 *
 *   This file is part of MoleCuilder.
 *
 *    MoleCuilder is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    MoleCuilder is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * AtomTypeDescriptor_impl.cpp
 *
 *  Created on: Feb 25, 2010
 *      Author: crueger
 */

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

//#include "CodePatterns/MemDebug.hpp"

#include "Descriptors/AtomTypeDescriptor.hpp"
#include "Descriptors/AtomTypeDescriptor_impl.hpp"

#include "Atom/atom.hpp"
#include "World.hpp"
#include "Element/periodentafel.hpp"

AtomTypeDescriptor_impl::AtomTypeDescriptor_impl(const element* _type) :
  type(_type)
{}

AtomTypeDescriptor_impl::~AtomTypeDescriptor_impl()
{}

bool AtomTypeDescriptor_impl::predicate(std::pair<atomId_t,const atom*> atom) const {
  return (atom.second->getType()==type);
}

AtomDescriptor AtomByType(const element *elem){
  return AtomDescriptor(AtomDescriptor::impl_ptr(new AtomTypeDescriptor_impl(elem)));
}

AtomDescriptor AtomByType(int Z){
  const element * elem = World::getInstance().getPeriode()->FindElement(Z);
  return AtomByType(elem);
}
